Page MenuHomeFreeBSD

readelf(1): Decode values when DT_FLAGS/DT_FLAGS_1
ClosedPublic

Authored by borako.ozarslan_gmail.com on Jan 8 2019, 6:26 PM.

Details

Summary

Decode d_val when the tag is DT_FLAGS or DT_FLAGS_1 based on the information at:

https://docs.oracle.com/cd/E23824_01/html/819-0690/chapter6-42444.html

PR: 232983
Submitted by: Bora Ozarslan borako.ozarslan@gmail.com

Test Plan

Compile a trivial program using the command cc -Wl,-z,now main.c and use readelf -d a.out on it.

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

emaste added inline comments.Jan 8 2019, 7:53 PM
contrib/elftoolchain/readelf/readelf.c
297–298 ↗(On Diff #52673)

should be in alpha order - i.e., before dump_dyn_val

emaste added inline comments.Jan 8 2019, 7:55 PM
contrib/elftoolchain/readelf/readelf.c
2852 ↗(On Diff #52673)

Why print "Flags:" for flags_1 and no prefix for flags above?

borako.ozarslan_gmail.com added inline comments.
contrib/elftoolchain/readelf/readelf.c
2852 ↗(On Diff #52673)

That's the behavior in GNU readelf as seen in the bug report

borako.ozarslan_gmail.com marked an inline comment as done.
borako.ozarslan_gmail.com marked an inline comment as done.
emaste accepted this revision.Jan 9 2019, 4:55 PM
This revision is now accepted and ready to land.Jan 9 2019, 4:55 PM
This revision was automatically updated to reflect the committed changes.
emaste added inline comments.Jan 30 2019, 8:44 PM
contrib/elftoolchain/readelf/readelf.c
2852 ↗(On Diff #52696)

FreeBSD style(9) has a space between if and (. Will update prior to commit.